import * as _jitl_quickjs_ffi_types from '@jitl/quickjs-ffi-types';
import { EmscriptenModuleLoader, QuickJSAsyncEmscriptenModule } from '@jitl/quickjs-ffi-types';
import { QuickJSAsyncFFI } from './ffi.mjs';

// Generated from ../../templates/emscripten-module.ASYNCIFY.d.ts

/**
 * Emscripten module built from [`quickjs/quickjs.h`](../quickjs/quickjs.h) and
 * our FFI support functions [c/interface.c](../c/interface.c), compiled with -s
 * ASYNCIFY=1.
 *
 * Because this version is built with ASYNCIFY, the C code can call asynchronous
 * Javascript functions as though they were synchronous.
 *
 * Note that emscripten modules returned by a `MODULARIZE=1` emscripten build
 * (like this one) load asynchronously.
 */
declare const ModuleLoader: EmscriptenModuleLoader<QuickJSAsyncEmscriptenModule>

declare namespace ___dist_emscripten_module_js {
  export { ModuleLoader as default };
}

/**
 * This export is a variant of the quickjs WASM library:
 * ### [@jitl/quickjs-singlefile-mjs-debug-asyncify](https://github.com/justjake/quickjs-emscripten/blob/main/doc/packages/@jitl/quickjs-singlefile-mjs-debug-asyncify/README.md)
 *
 * Variant with the WASM data embedded into a NodeJS ESModule.
 *
 * | Variable            |    Setting                     |    Description    |
 * | --                  | --                             | --                |
 * | releaseMode         | debug         | Enables assertions and memory sanitizers. Try to run your tests against debug variants, in addition to your preferred production variant, to catch more bugs. |
 * | syncMode            | asyncify            | Build run through the ASYNCIFY WebAssembly transform. Larger and slower. Allows synchronous calls from the WASM runtime to async functions on the host. The extra magic makes this variant slower than sync variants. Note that both variants support regular async functions. Only adopt ASYNCIFY if you need to! |
 * | emscriptenInclusion | singlefile | The WASM runtime is included directly in the JS file. Use if you run into issues with missing .wasm files when building or deploying your app. |
 * | exports             | import                  | Has these package.json export conditions |
 *
 */
declare const variant: {
    readonly type: "async";
    readonly importFFI: () => Promise<(new (module: _jitl_quickjs_ffi_types.QuickJSAsyncEmscriptenModule) => _jitl_quickjs_ffi_types.QuickJSAsyncFFI) | typeof QuickJSAsyncFFI>;
    readonly importModuleLoader: () => Promise<typeof ___dist_emscripten_module_js | _jitl_quickjs_ffi_types.EmscriptenModuleLoader<_jitl_quickjs_ffi_types.QuickJSAsyncEmscriptenModule> | {
        default: _jitl_quickjs_ffi_types.EmscriptenModuleLoader<_jitl_quickjs_ffi_types.QuickJSAsyncEmscriptenModule>;
    } | {
        default: {
            default: _jitl_quickjs_ffi_types.EmscriptenModuleLoader<_jitl_quickjs_ffi_types.QuickJSAsyncEmscriptenModule>;
        };
    }>;
};

export { variant as default };
